configure: fix mfloat-abi detection
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 echo "" > $TMPC
28 $CC -E -dD $CFLAGS $TMPC | grep -q $1 || return 1
29 return 0
30}
31
32# setting options to "yes" or "no" will make that choice default,
33# "" means "autodetect".
34
35platform_list="generic pandora maemo caanoo libretro"
36platform="generic"
37builtin_gpu_list="peops unai neon"
38builtin_gpu=""
39sound_driver_list="oss alsa sdl pulseaudio libretro"
40sound_drivers=""
41plugins="plugins/spunull/spunull.so \
42plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
43ram_fixed="no"
44drc_cache_base="no"
45have_armv6=""
46have_armv7=""
47have_arm_neon=""
48have_tslib=""
49enable_dynarec="yes"
50need_sdl="no"
51# these are for known platforms
52optimize_cortexa8="no"
53optimize_arm926ej="no"
54
55# hardcoded stuff
56CC="${CC-${CROSS_COMPILE}gcc}"
57CXX="${CXX-${CROSS_COMPILE}g++}"
58AS="${AS-${CROSS_COMPILE}as}"
59AR="${AS-${CROSS_COMPILE}ar}"
60MAIN_LDLIBS="$LDLIBS -ldl -lm"
61config_mak="config.mak"
62
63fail()
64{
65 echo "$@"
66 exit 1
67}
68
69# call during arg parsing, so that cmd line can override platform defaults
70set_platform()
71{
72 platform=$1
73 case "$platform" in
74 generic)
75 ;;
76 pandora)
77 sound_drivers="oss alsa"
78 ram_fixed="yes"
79 drc_cache_base="yes"
80 optimize_cortexa8="yes"
81 have_arm_neon="yes"
82 ;;
83 maemo)
84 ram_fixed="yes"
85 drc_cache_base="yes"
86 optimize_cortexa8="yes"
87 have_arm_neon="yes"
88 ;;
89 caanoo)
90 sound_drivers="oss"
91 ram_fixed="yes"
92 drc_cache_base="yes"
93 optimize_arm926ej="yes"
94 ;;
95 libretro)
96 sound_drivers="libretro"
97 ;;
98 *)
99 fail "unsupported platform: $platform"
100 ;;
101 esac
102}
103
104for opt do
105 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
106 case "$opt" in
107 --help|-h) show_help="yes"
108 ;;
109 --platform=*) set_platform "$optarg"
110 ;;
111 --gpu=*) builtin_gpu="$optarg"
112 ;;
113 --sound-drivers=*) sound_drivers="$optarg"
114 ;;
115 --enable-neon) have_arm_neon="yes"
116 ;;
117 --disable-neon) have_arm_neon="no"
118 ;;
119 --disable-dynarec) enable_dynarec="no"
120 ;;
121 *) echo "ERROR: unknown option $opt"; show_help="yes"
122 ;;
123 esac
124done
125
126if [ "$show_help" = "yes" ]; then
127 echo "options:"
128 echo " --help print this message"
129 echo " --platform=NAME target platform [$platform]"
130 echo " available: $platform_list"
131 echo " --gpu=NAME builtin gpu plugin [guessed]"
132 echo " available: $builtin_gpu_list"
133 echo " --sound-drivers=LIST sound output drivers [guessed]"
134 echo " available: $sound_driver_list"
135 echo " --enable-neon"
136 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
137 echo " --disable-dynarec disable dynamic recompiler"
138 echo " (dynarec is only available and enabled on ARM)"
139 echo "influential environment variables:"
140 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
141 exit 1
142fi
143
144# validate selections
145if [ "x$builtin_gpu" != "x" ]; then
146 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
147 fail "unsupported builtin gpu plugin: $builtin_gpu"
148 fi
149fi
150
151if [ "x$sound_drivers" != "x" ]; then
152 for d in $sound_drivers; do
153 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
154 fail "unsupported sound driver: $sound_driver"
155 fi
156 done
157fi
158
159if [ -z "$ARCH" ]; then
160 ARCH=`$CC -v 2>&1 | grep -i 'target:' | awk '{print $2}' \
161 | awk -F '-' '{print $1}'`
162fi
163
164# ARM stuff
165if [ "$ARCH" = "arm" ]; then
166 if [ "$optimize_cortexa8" = "yes" ]; then
167 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
168 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
169 fi
170 if [ "$optimize_arm926ej" = "yes" ]; then
171 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
172 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
173 fi
174
175 if [ "x$have_arm_neon" = "x" ]; then
176 # detect NEON from user-supplied cflags to enable asm code
177 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
178 fi
179 if [ "x$have_armv6" = "x" ]; then
180 have_armv6=`check_define __ARM_ARCH_6 && echo yes` || true
181 fi
182 if [ "x$have_armv7" = "x" ]; then
183 if check_define __ARM_ARCH_7A__; then
184 have_armv6="yes"
185 have_armv7="yes"
186 fi
187 fi
188
189 if [ "x$builtin_gpu" = "x" ]; then
190 if [ "$have_arm_neon" = "yes" ]; then
191 builtin_gpu="neon"
192 elif [ "$have_armv7" != "yes" ]; then
193 # pre-ARMv7 hardware is usually not fast enough for peops
194 builtin_gpu="unai"
195 else
196 builtin_gpu="peops"
197 fi
198 fi
199
200 # automatically set mfpu and mfloat-abi if they are not set
201 if [ "$have_arm_neon" = "yes" ]; then
202 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=neon"
203 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=neon"
204 elif [ "$have_armv6" = "yes" ]; then
205 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=vfp"
206 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=vfp"
207 fi
208 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes`
209 if [ "$floatabi_set_by_gcc" != "yes" -a "$have_armv6" = "yes" ]; then
210 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
211 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
212 fi
213
214 # must disable -mthumb as recompiler can't handle it
215 if check_define __thumb__; then
216 CFLAGS="$CFLAGS -mno-thumb"
217 fi
218
219 if [ "$have_armv7" = "yes" ]; then
220 ASFLAGS="$ASFLAGS --defsym HAVE_ARMV7=1"
221 else
222 ASFLAGS="$ASFLAGS --defsym HAVE_ARMV7=0"
223 fi
224else
225 # dynarec only available on ARM
226 enable_dynarec="no"
227fi
228
229if [ "x$builtin_gpu" = "x" ]; then
230 builtin_gpu="peops"
231fi
232
233if [ "$ARCH" = "x86_64" ]; then
234 # currently we are full of 32bit assumptions,
235 # at least savestate compatibility will break without these
236 CFLAGS="$CFLAGS -m32"
237 LDFLAGS="$LDFLAGS -m32"
238fi
239
240# supposedly we can avoid -fPIC on armv5 for slightly better performace?
241if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
242 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
243fi
244
245if [ "$ram_fixed" = "yes" ]; then
246 CFLAGS="$CFLAGS -DRAM_FIXED"
247fi
248
249case "$platform" in
250generic)
251 need_sdl="yes"
252 ;;
253maemo)
254 maemo_cflags=`pkg-config --cflags hildon-1`
255 maemo_ldlibs=`pkg-config --libs hildon-1`
256 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES $maemo_cflags"
257 MAIN_LDLIBS="$MAIN_LDLIBS $maemo_ldlibs"
258 ;;
259libretro)
260 CFLAGS="$CFLAGS -fPIC"
261 LDFLAGS="$LDFLAGS -shared"
262 ;;
263esac
264
265# header/library presence tests
266check_zlib()
267{
268 cat > $TMPC <<EOF
269 #include <zlib.h>
270 void main() { uncompress(0, 0, 0, 0); }
271EOF
272 compile_binary
273}
274
275check_bzlib()
276{
277 cat > $TMPC <<EOF
278 #include <bzlib.h>
279 void main() { BZ2_bzBuffToBuffDecompress(0, 0, 0, 0, 0, 0); }
280EOF
281 compile_object
282}
283
284check_libpng()
285{
286 cat > $TMPC <<EOF
287 #include <png.h>
288 void main() { png_init_io(0, 0); }
289EOF
290 compile_binary
291}
292
293check_oss()
294{
295 cat > $TMPC <<EOF
296 #include <sys/soundcard.h>
297 #include <sys/ioctl.h>
298 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
299EOF
300 compile_binary
301}
302
303check_alsa()
304{
305 cat > $TMPC <<EOF
306 #include <alsa/asoundlib.h>
307 void main() { snd_pcm_open(0, 0, 0, 0); }
308EOF
309 compile_binary "$@"
310}
311
312check_sdl()
313{
314 cat > $TMPC <<EOF
315 #include <SDL.h>
316 void main() { SDL_OpenAudio(0, 0); }
317EOF
318 compile_binary "$@"
319}
320
321MAIN_LDLIBS="$MAIN_LDLIBS -lz"
322check_zlib || fail "please install zlib/libz-dev"
323
324check_bzlib || fail "please install bz2lib/libbz2-dev"
325
326MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
327check_libpng || fail "please install libpng/libpng-dev"
328
329# find what audio support we can compile
330if [ "x$sound_drivers" = "x" ]; then
331 if check_oss; then sound_drivers="$sound_drivers oss"; fi
332 if check_alsa -lasound; then
333 sound_drivers="$sound_drivers alsa"
334 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
335 fi
336 if [ "$need_sdl" == "yes" ] || check_sdl `sdl-config --cflags -libs`; then
337 sound_drivers="$sound_drivers sdl"
338 need_sdl="yes"
339 fi
340else
341 if echo $sound_drivers | grep -q "\<oss\>"; then
342 check_oss || fail "oss support is missing"
343 fi
344 if echo $sound_drivers | grep -q "\<alsa\>"; then
345 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
346 check_alsa || fail "please install libasound2-dev"
347 fi
348fi
349
350if [ "$need_sdl" == "yes" ]; then
351 CFLAGS="$CFLAGS `sdl-config --cflags`"
352 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
353 check_sdl || fail "please install libsdl1.2-dev"
354fi
355
356# check for tslib (only headers needed)
357if [ "x$have_tslib" = "x" ]; then
358 cat > $TMPC <<EOF
359 #include <tslib.h>
360 void test(struct ts_sample sample) {}
361EOF
362 if compile_object; then
363 have_tslib="yes"
364 else
365 have_tslib="no"
366 fi
367fi
368
369# check for GLES headers
370cat > $TMPC <<EOF
371#include <GLES/gl.h>
372#include <GLES/glext.h>
373#include <EGL/egl.h>
374void *test(void) {
375 return eglGetDisplay( (EGLNativeDisplayType)0 );
376}
377EOF
378if compile_object; then
379 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
380fi
381
382if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
383 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
384fi
385
386# short plugin list for display
387for p in $plugins; do
388 p1=`basename $p`
389 plugins_short="$p1 $plugins_short"
390done
391
392# set things that failed to autodetect to "no"
393test "x$have_armv6" != "x" || have_armv6="no"
394test "x$have_armv7" != "x" || have_armv7="no"
395test "x$have_arm_neon" != "x" || have_arm_neon="no"
396
397echo "architecture $ARCH"
398echo "platform $platform"
399echo "built-in GPU $builtin_gpu"
400echo "sound drivers $sound_drivers"
401echo "plugins $plugins_short"
402echo "C compiler $CC"
403echo "C compiler flags $CFLAGS"
404echo "libraries $MAIN_LDLIBS"
405echo "linker flags $LDFLAGS"
406echo "enable dynarec $enable_dynarec"
407echo "ARMv7 optimizations $have_armv7"
408echo "enable ARM NEON $have_arm_neon"
409echo "tslib support $have_tslib"
410
411echo "# Automatically generated by configure" > $config_mak
412printf "# Configured with:" >> $config_mak
413printf " '%s'" "$0" "$@" >> $config_mak
414echo >> $config_mak
415
416echo "CC = $CC" >> $config_mak
417echo "CXX = $CXX" >> $config_mak
418echo "AS = $AS" >> $config_mak
419echo "CFLAGS += $CFLAGS" >> $config_mak
420echo "ASFLAGS += $ASFLAGS" >> $config_mak
421echo "LDFLAGS += $LDFLAGS" >> $config_mak
422echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
423echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
424echo >> $config_mak
425
426if [ "$platform" = "libretro" ]; then
427 echo "TARGET = libretro.so" >> $config_mak
428fi
429echo "ARCH = $ARCH" >> $config_mak
430echo "PLATFORM = $platform" >> $config_mak
431echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
432echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
433if [ "$ARCH" = "arm" ]; then
434 echo "PLUGINS = $plugins" >> $config_mak
435else
436 echo -n "PLUGINS =" >> $config_mak
437 for p in $plugins; do
438 echo -n " ${p}.${ARCH}" >> $config_mak
439 done
440 echo >> $config_mak
441fi
442if [ "$have_armv6" = "yes" ]; then
443 echo "HAVE_ARMV6 = 1" >> $config_mak
444fi
445if [ "$have_armv7" = "yes" ]; then
446 echo "HAVE_ARMV7 = 1" >> $config_mak
447fi
448if [ "$have_arm_neon" = "yes" ]; then
449 echo "HAVE_NEON = 1" >> $config_mak
450fi
451if [ "$have_tslib" = "yes" ]; then
452 echo "HAVE_TSLIB = 1" >> $config_mak
453fi
454if [ "$enable_dynarec" = "yes" ]; then
455 echo "USE_DYNAREC = 1" >> $config_mak
456fi
457if [ "$drc_cache_base" = "yes" ]; then
458 echo "DRC_CACHE_BASE = 1" >> $config_mak
459fi
460
461# use pandora's skin (for now)
462test -e skin || ln -s frontend/pandora/skin skin
463
464# vim:shiftwidth=2:expandtab